# Generated by rust2rpm 26
%bcond_without check

Name:           trustee-client
Version:        0.10.0
Release:        1%{dist}.uri7
Summary:        Attest and fetch secrets from Trustee

SourceLicense:  Apache-2.0
# FIXME: paste output of %%cargo_license_summary here
License:        Apache-2.0
# LICENSE.dependencies contains a full license breakdown

URL:            https://github.com/confidential-containers/guest-components
Source:         guest-components-0.10.0.tar.gz


Patch0001:      0001-Add-trustee-client-a-simple-client-for-Trustee.patch
Patch0002:      0002-trustee-client-use-config-file.patch
Patch0003:      0003-trustee-client-add-README.md.patch
#Patch0004:      0004-Fedora-Remove-workspace-members-which-are-not-built.patch
Patch0004:      0004-Fedora-Remove-workspace-members.patch
Patch0005:      0005-Fedora-protobuf-2.28.0.patch
Patch0006:      0006-Fedora-use-the-installed-openssl-not-vendored.patch
Patch0007:      0007-Fedora-kbs_protocol-Cargo.toml-use-non-vendored-reqw.patch
Patch0008:      0008-Fedora-rstest-0.18.patch
Patch0009:      0009-Fedora-remove-jwt-simple-dependency.patch
Patch0010:      0010-Fedora-remove-ttrpc-grpc-dependency.patch
Patch0011:      0011-Fedora-remove-tonic-dependency.patch
Patch0012:      0012-Fedora-remove-prost-dependency.patch
Patch0013:      0013-Fedora-remove-foreign-types-dependency.patch
Patch0014:      0014-Fedora-remove-all-dependencies-of-non-built-attester.patch
Patch0015:      0015-Fedora-remove-testcontainers-dependency.patch
Patch0016:      0016-Fedora-set-openssl-by-default-kbs_protocol-AA.patch
Patch0017:      0017-Fedora-Remove-non-openssl-dependencies.patch
Patch0018:      0018-Fedora-set-async-trait-to-0.1.81.patch
Patch0019:      0019-Fedora-default-for-kbc-cc_kbc-openssl.patch
Patch0020:      0020-Fedora-AA-get-all-attesters-from-kbs_protocol.patch
Patch0021:      0021-Fedora-add-az-snp-vtpm-attester.patch
Patch0022:      0022-Fedora-add-az-tdx-vtpm-attesster.patch

#Patch0023:      0023-Cargo.lock-update.patch

Patch0024:      0024-MERGEME-Add-trustee-client.patch

# for az-tdx-vtpm-attester which requires az-tdx-vtpm 0.7.0
# which requires sev 4.0.0 which is not yet built in Fedora
Patch0900:      0900-Fedora-attester-az-tdx-vtpm-revert-3bcbfcc9.patch

Patch1000:      1000-SPLITME-Cargo.toml-fixes.patch
#Patch1001:      1001-MERGEME-fixing-Cargo.lock.patch

BuildRequires:  cargo-rpm-macros >= 24
BuildRequires:  openssl-devel

%if 1
# automatic BuildRequires seems wrong
# add BuildRequires lines manually.

BuildRequires: rust-anyhow-devel >= 1.0
BuildRequires: rust-assert-json-diff-devel >= 2.0 
BuildRequires: rust-async-trait-devel >= 0.1.81
BuildRequires: rust-az-cvm-vtpm-devel >= 0.6.0
BuildRequires: rust-az-snp-vtpm-devel >= 0.6.0
BuildRequires: rust-base64-devel >= 0.22
# BuildRequires: rust-base64-serde-devel >= 0.7
BuildRequires: rust-bincode-devel >= 1.3.3
BuildRequires: rust-cfg-if-devel >= 1.0.0
BuildRequires: rust-chrono-devel >= 0.4.38
BuildRequires: rust-clap-devel >= 4.5.16
BuildRequires: rust-config-devel >= 0.13.4
BuildRequires: rust-const_format-devel >= 0.2.32
BuildRequires: rust-env_logger-devel >= 0.11.5
BuildRequires: rust-hex-devel >= 0.4.3
BuildRequires: rust-hmac-devel >= 0.12.1
BuildRequires: rust-jsonwebkey-devel >= 0.3.5
BuildRequires: rust-kbs-types-devel >= 0.7.0
BuildRequires: rust-lazy_static-devel >= 1.5.0
BuildRequires: rust-log-devel >= 0.4.22
BuildRequires: rust-openssl-devel >= 0.10
BuildRequires: rust-openssl-sys-devel >= 0.9
BuildRequires: rust-protobuf-devel >= 2.28.0
BuildRequires: rust-rand-devel >= 0.8.5
BuildRequires: rust-reqwest-devel >= 0.12
BuildRequires: rust-ring-devel >= 0.17
BuildRequires: rust-rstest-devel >= 0.18
BuildRequires: rust-serde-devel >= 1.0
BuildRequires: rust-serde+derive-devel >= 1.0
BuildRequires: rust-serde_with1-devel >= 1.14.0
BuildRequires: rust-serde_with1+base64-devel >= 1.14.0
BuildRequires: rust-serde_json-devel >= 1.0
BuildRequires: rust-serial_test-devel >= 3
BuildRequires: rust-sev-devel >= 3.1
BuildRequires: rust-sha2-devel >= 0.10.8
BuildRequires: rust-strum-devel >= 0.26
BuildRequires: rust-strum+derive-devel >= 0.26
BuildRequires: rust-tempfile-devel >= 3.11
BuildRequires: rust-thiserror-devel >= 1.0
BuildRequires: rust-tokio-devel >= 1.39
BuildRequires: rust-toml-devel >= 0.8.19
BuildRequires: rust-url-devel >= 2.5.2
BuildRequires: rust-uuid-devel >= 1
BuildRequires: rust-yasna-devel >= 0.5.2
BuildRequires: rust-zeroize-devel >= 1.8.1
%endif

# currently only works on AMD
ExclusiveArch:  x86_64


%global _description %{expand:
%{summary}.}

%description %{_description}

%prep
%autosetup -n guest-components-%{version} -p1

# TODO: Fix Cargo.lock, such that it correctly builds BuildRequires lines.
# Currently it insists e.g. on clap 4.2.7 so remove it
rm -f Cargo.lock

# followup on Patch0004: delete directories
rm -rf \
    api-server-rest \
    attestation-agent/coco_keyprovider \
    confidential-data-hub \
    image-rs \
    ocicrypt-rs \

cd trustee-client

# Copy trustee-client README.md file
cp -f README.md ..

%cargo_prep

%generate_buildrequires
%cargo_generate_buildrequires

%build
cd trustee-client
%cargo_build
%{cargo_license_summary}
%{cargo_license} > ../LICENSE.dependencies

%install
cd trustee-client
%cargo_install

%if %{with check}
%check
cd trustee-client
%cargo_test
%endif

%files
%license LICENSE
%license LICENSE.dependencies
%doc README.md
%{_bindir}/trustee-client

%changelog
%autochangelog
